import java.awt.*;
import java.applet.*;
import static java.lang.Math.*;
public class victorTest
{
    /*________________________________
    ___________Variable_____________*/
    pigFunc pig;
    vectorFunc v;
    int [] a,
           b,
           c,
           d,
           r,
           center;
    
    int[] point,
           p1,
           p2;
           
    victorFunc vi = new victorFunc();

    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {
        pig = new pigFunc();
        v = new vectorFunc();
        //System.out.println("vector d: " + d.x + "," + d.y);
        
        a = vi.nuVictor(50,360);
        b = vi.nuVictor(200,360);
        c = vi.nuVictor(200,510);
        d = vi.nuVictor(50,510);
        //r = vi.nuVictor(5,30);    //from radian 0.03
        r = vi.nuVictor(sin(0.05), cos(0.05));
        center = vi.nuVictor(125,435);
        
        point = vi.nuVictor(250,410);
        
        p1 = vi.nuVictor(25,460);
        p2 = vi.nuVictor(125,535);
        
        System.out.println(1 << vi.fpoint);
        System.out.println(vi.reInt(0x7FFFFFFF));
        System.out.println(r[0] +" "+  r[1]);
        System.out.println(vi.x(r) +" "+  vi.y(r));
        System.out.println(vi.x(center) +" "+  vi.y(center));
        System.out.println(vi.x(vi.rotate(center,r)) +" "+  vi.y(vi.rotate(center,r)));
       
    }
    /*________________________________
    ___________Main Loop____________*/
    public void loop()
    {
        a = vi.add(center,vi.rotate(vi.sub(a,center),r));
        b = vi.add(center,vi.rotate(vi.sub(b,center),r));
        c = vi.add(center,vi.rotate(vi.sub(c,center),r));
        d = vi.add(center,vi.rotate(vi.sub(d,center),r));
//        a = vi.add(center,vi.sub(a,center));
//        b = vi.add(center,vi.sub(b,center));
//        c = vi.add(center,vi.sub(c,center));
//        d = vi.add(center,vi.sub(d,center));
    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(0,350,100,350);
        g.drawString("victor Test , integer math",102,354);
        
        //draw rotating box
        g.setColor(Color.red);
        g.drawLine(vi.x(a), vi.y(a), vi.x(b), vi.y(b));
        g.setColor(Color.black);
        g.drawString("A", vi.x(a)+5,vi.y(a)+5);
        g.setColor(Color.blue);
        g.drawLine(vi.x(b), vi.y(b), vi.x(c), vi.y(c));
        g.setColor(Color.black);
        g.drawString("B", vi.x(b)+5,vi.y(b)+5);
        g.setColor(Color.green);
        g.drawLine(vi.x(c), vi.y(c), vi.x(d), vi.y(d));
        g.setColor(Color.black);
        g.drawString("C", vi.x(c)+5,vi.y(c)+5);
        g.setColor(Color.orange);
        g.drawLine(vi.x(d), vi.y(d), vi.x(a), vi.y(a));
        g.setColor(Color.black);
        g.drawString("D", vi.x(d)+5,vi.y(d)+5);
        
        //draw center
        g.setColor(Color.black);
        g.fillRect(vi.x(center)-2,vi.y(center)-2, 5,5);
        g.setColor(Color.black);
        g.drawString("center", vi.x(center)+5,vi.y(center)+5);
        
        //draw point for closest test
        g.setColor(Color.blue);
        g.fillRect(vi.x(point)-2,vi.y(point)-2, 5,5);
        g.setColor(Color.black);
        g.drawString("point", vi.x(point)+5,vi.y(point)+5);
        
        //draw line for intersect test
        g.setColor(Color.cyan);
        g.drawLine(vi.x(p1), vi.y(p1), vi.x(p2), vi.y(p2));
        g.setColor(Color.black);
        g.drawString("p1", vi.x(p1)+5,vi.y(p1)+5);
        g.drawString("p2", vi.x(p2)+5,vi.y(p2)+5);
        
        //closest point test
        int u = vi.closestU(point,a,b);
        if (u > vi.unInt(0) && u < vi.unInt(1))        //black if the point is really on the line , gray otherwise
        {
            g.setColor(Color.black);
        }
        else
        {
            g.setColor(Color.gray);
        }
        int[] closest = vi.closest(point,a,b, u);
        g.fillRect(vi.x(closest)-2,vi.y(closest)-2, 5,5);
        g.drawString("closest to point in line A B", vi.x(closest)+5,vi.y(closest)+5);
        //show the perpendicularity of the closest point
        g.drawLine(vi.x(closest), vi.y(closest), vi.x(point), vi.y(point));
        
        //intersect
        int pZero = vi.parallelZero(p1,p2,b,c);
        if (pZero != vi.unInt(0))             //no intersection if line are parallel
        {
            int Ua = vi.intersectUa(p1,p2,b,c,pZero);
            int Ub = vi.intersectUb(p1,p2,b,c,pZero);
            if ((Ua < 0 || Ua > vi.unInt(1)) && (Ub < 0 || Ub > vi.unInt(1)))   //do line really intersect between their point
            {
                g.setColor(Color.gray);
            }
            else
            {
                g.setColor(Color.black);
            }
            int[] intersect = vi.intersect(p1,p2, Ua);
            g.fillRect(vi.x(intersect)-2,vi.y(intersect)-2, 5,5);
            g.drawString("intersect B C with P1 P2", vi.x(intersect)+5,vi.y(intersect)+5);
        }
        

    }
}
