import static java.lang.Math.*;
public class victorFunc{
    //fact about java
    //all arithmetic operation preserve sign
    // right shift operation preserve sign, but , special dont  >>>
    // does not affect left shift
    // all logical operation dont care about sign
    //consider int as a blob
    //dont do anything beyond logical op on int
    //-10 << 1 = -20 >> 1 = -5 >>> 1 = 2147483643
    
/*
this experiment prove that java accept runtime declaration of array between {brace}
but wont simply return {...}
need initialisation of temporary var before
*/
/*
first i need to elaborate a setting of fixed point
first idea was in 16bits signed with 5 bits shift
i cant reproduce it here
it shrink the square :o(
16.16 work fine
20.12 work fine
*/

    final static int fpoint = 12;
    
    public static int reInt(int a)
    {
        return a >> fpoint;
    }
    
    public static int unInt(int a)
    {
        return a << fpoint;
    }
    
    public static int[] nuVictor(int x, int y)
    {
        int tmp[] = { unInt(x), unInt(y)};
        return tmp;
    }

    public static int[] nuVictor(float x, float y)
    {
        int tmp[] = { round(x*(1<<fpoint)), round(y*(1<<fpoint)) };
        return tmp;
    }
    
    public static int[] nuVictor(double x, double y)
    {
        int tmp[] = { (int)round(x*(1<<fpoint)), (int)round(y*(1<<fpoint)) };
        return tmp;
    }
    
    public static int x(int [] a)
    {
        return reInt(a[0]);
    }
    
    public static int y(int []a)
    {
        return reInt(a[1]);
    }
    
    public static int mul(int a, int b)
    {
        return (int)(((long)a*b)>>fpoint);
    }
    
    public static int div(int a, int b)
    {
        if(b!=0)
            return (int)(((long)a << fpoint)/b);
        return 0;
    }
    
    /*
    function
    */

    public static int[] add(int[] a, int[] b)
    {
        int tmp[] = {a[0]+b[0], a[1]+b[1]};
        return tmp;
    }



    public static int[] sub(int[] a, int[] b)
    {
        int tmp[] = {a[0]-b[0], a[1]-b[1]};
        return tmp;
    }

    
    /*
    */
    
    public static int[] scale(int[] a, int b)
    {
        //int tmp[] = {correctAfterMul(a[0]*b), correctAfterMul(a[1]*b)};
        int tmp[] = {mul(a[0],b), mul(a[1],b)};
        return tmp;
    }

    public static int dot(int[] a, int[] b)
    {
        //eturn correctAfterMul(a[0]*b[0] + a[1]*b[1]);
        return mul(a[0],b[0]) + mul(a[1],b[1]);
    }

    public static int cross(int[] a, int[] b)
    {
        //return correctAfterMul(a[0]*b[1] - a[1]*b[0]);
        return mul(a[0],b[1]) - mul(a[1],b[0]);
    }

    public static int magSQ(int[] a)
    {
        return mul(a[0],a[0])+mul(a[1],a[1]);
    }

    //a.x * r.y - a.y * r.x, 
    //a.x * r.x + a.y * r.y
    public static int[] rotate(int[] a, int[] r)
    {
        int tmp[] = {cross(a,r), dot(a,r)};
        return tmp;
    }

    /*
    */
    
    public static int closestU(int[] a, int[] p1, int[] p2)
    {
        int[] delta = sub(p2,p1);
        return div(dot(sub(a,p1),delta), magSQ(delta));
    }
    
    public static int[] closest(int[] a, int[] p1, int[] p2, int U)
    {
        return add(p1, scale(sub(p2,p1),U));
    }
    
    public static int[] closest(int[] a, int[] p1, int[] p2)
    {
        int[] delta = sub(p2,p1);
        int u = div(dot(sub(a,p1), delta), magSQ(delta));
        return add(p1, scale(delta,u));
    }

    /*
    */

    public static int parallelZero(int[] p1, int[] p2, int[] p3, int[] p4)
    {
        return cross(sub(p2,p1), sub(p4,p3));
    }
    
    public static int intersectUa(int[] p1, int[] p2, int[] p3, int[] p4, int pZero)
    {
        int[] delta = sub(p4,p3);
        int[] deltaWTF = sub(p1,p3);
        return div(cross(delta,deltaWTF), pZero);
    }
    
    public static int intersectUb(int[] p1, int[] p2, int[] p3, int[] p4, int pZero)
    {
        int[] delta = sub(p2,p1);
        int[] deltaWTF = sub(p1,p3);
        return div(cross(delta,deltaWTF),pZero);
    }
    
    public static int[] intersect(int[] p1, int[] p2, int[] p3, int[] p4)
    {
        int pZero = parallelZero(p1,p2,p3,p4);
        int Ua = intersectUa(p1,p2,p3,p4,pZero);
        return add(p1,scale(sub(p2,p1),Ua));
    }
    
    public static int[] intersect(int[] p1, int[] p2, int Ua)
    {
        return add(p1,scale(sub(p2,p1),Ua));
    }
    
};
